package tools.descartes.dql.connector.vsp;

import org.apache.log4j.Logger;

import tools.descartes.dql.connector.ConnectorProvider;
import tools.descartes.dql.connector.ModelStructureQueryConnector;
import tools.descartes.dql.connector.PerformanceIssueQueryConnector;
import tools.descartes.dql.connector.PerformanceMetricsQueryConnector;
import tools.descartes.dql.core.engine.util.DQLLogger;

public class ConnectorProviderImpl implements ConnectorProvider {
	private final Logger log = DQLLogger.getLogger(this.getClass().getName());

	@Override
	public ModelStructureQueryConnector createModelStructureQueryConnectorInstance() {
		log.info("Creating a new instance of ModelStructureQueryConnector");
		return new ModelStructureQueryConnectorImpl();
	}

	@Override
	public PerformanceIssueQueryConnector createPerformanceIssueQueryConnectorInstance() {
		log.error("PerformanceIssueQueryConnector not supported");
		return null;
	}

	@Override
	public PerformanceMetricsQueryConnector createPerformanceMetricsQueryConnectorInstance() {
		log.info("Creating a new instance of PerformanceMetricsQueryConnector");
		return new PerformanceMetricsQueryConnectorImpl();
	}

}
