/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Observe Between Clause</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode1 <em>Mode1</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getStartingTime <em>Starting Time</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode2 <em>Mode2</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getEndingTime <em>Ending Time</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getObserveBetweenClause()
 * @model
 * @generated
 */
public interface ObserveBetweenClause extends ObservationClause
{
  /**
   * Returns the value of the '<em><b>Mode1</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode1</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode1</em>' attribute.
   * @see #setMode1(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getObserveBetweenClause_Mode1()
   * @model
   * @generated
   */
  String getMode1();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode1 <em>Mode1</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode1</em>' attribute.
   * @see #getMode1()
   * @generated
   */
  void setMode1(String value);

  /**
   * Returns the value of the '<em><b>Starting Time</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Starting Time</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Starting Time</em>' containment reference.
   * @see #setStartingTime(BetweenTimeClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getObserveBetweenClause_StartingTime()
   * @model containment="true"
   * @generated
   */
  BetweenTimeClause getStartingTime();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getStartingTime <em>Starting Time</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Starting Time</em>' containment reference.
   * @see #getStartingTime()
   * @generated
   */
  void setStartingTime(BetweenTimeClause value);

  /**
   * Returns the value of the '<em><b>Mode2</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Mode2</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Mode2</em>' attribute.
   * @see #setMode2(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getObserveBetweenClause_Mode2()
   * @model
   * @generated
   */
  String getMode2();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getMode2 <em>Mode2</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Mode2</em>' attribute.
   * @see #getMode2()
   * @generated
   */
  void setMode2(String value);

  /**
   * Returns the value of the '<em><b>Ending Time</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Ending Time</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Ending Time</em>' containment reference.
   * @see #setEndingTime(BetweenTimeClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getObserveBetweenClause_EndingTime()
   * @model containment="true"
   * @generated
   */
  BetweenTimeClause getEndingTime();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.ObserveBetweenClause#getEndingTime <em>Ending Time</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Ending Time</em>' containment reference.
   * @see #getEndingTime()
   * @generated
   */
  void setEndingTime(BetweenTimeClause value);

} // ObserveBetweenClause
