/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Relative Time With Sign Clause</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getSign <em>Sign</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getTimeClause <em>Time Clause</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getRelativeTimeWithSignClause()
 * @model
 * @generated
 */
public interface RelativeTimeWithSignClause extends BetweenTimeClause
{
  /**
   * Returns the value of the '<em><b>Sign</b></em>' attribute.
   * The literals are from the enumeration {@link tools.descartes.dql.lang.descartesQL.RelativeTimeSignType}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Sign</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Sign</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeSignType
   * @see #setSign(RelativeTimeSignType)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getRelativeTimeWithSignClause_Sign()
   * @model
   * @generated
   */
  RelativeTimeSignType getSign();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getSign <em>Sign</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Sign</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.RelativeTimeSignType
   * @see #getSign()
   * @generated
   */
  void setSign(RelativeTimeSignType value);

  /**
   * Returns the value of the '<em><b>Time Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Time Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Time Clause</em>' containment reference.
   * @see #setTimeClause(RelativeTimeClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getRelativeTimeWithSignClause_TimeClause()
   * @model containment="true"
   * @generated
   */
  RelativeTimeClause getTimeClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.RelativeTimeWithSignClause#getTimeClause <em>Time Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Time Clause</em>' containment reference.
   * @see #getTimeClause()
   * @generated
   */
  void setTimeClause(RelativeTimeClause value);

} // RelativeTimeWithSignClause
