/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>What If Variation Clause</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getVariationPoint <em>Variation Point</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getValues <em>Values</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfVariationClause()
 * @model
 * @generated
 */
public interface WhatIfVariationClause extends EObject
{
  /**
   * Returns the value of the '<em><b>Variation Point</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Variation Point</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Variation Point</em>' attribute.
   * @see #setVariationPoint(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfVariationClause_VariationPoint()
   * @model
   * @generated
   */
  String getVariationPoint();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getVariationPoint <em>Variation Point</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Variation Point</em>' attribute.
   * @see #getVariationPoint()
   * @generated
   */
  void setVariationPoint(String value);

  /**
   * Returns the value of the '<em><b>Values</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Values</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Values</em>' containment reference.
   * @see #setValues(WhatIfValueVariationClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getWhatIfVariationClause_Values()
   * @model containment="true"
   * @generated
   */
  WhatIfValueVariationClause getValues();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.WhatIfVariationClause#getValues <em>Values</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Values</em>' containment reference.
   * @see #getValues()
   * @generated
   */
  void setValues(WhatIfValueVariationClause value);

} // WhatIfVariationClause
