/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.FilteringClause;
import tools.descartes.dql.lang.descartesQL.FilteringRule;
import tools.descartes.dql.lang.descartesQL.FilteringStrategy;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Filtering Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.FilteringClauseImpl#getFilteringRule <em>Filtering Rule</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.FilteringClauseImpl#getFilteringStrategy <em>Filtering Strategy</em>}</li>
 * </ul>
 *
 * @generated
 */
public class FilteringClauseImpl extends MinimalEObjectImpl.Container implements FilteringClause
{
  /**
   * The cached value of the '{@link #getFilteringRule() <em>Filtering Rule</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFilteringRule()
   * @generated
   * @ordered
   */
  protected FilteringRule filteringRule;

  /**
   * The cached value of the '{@link #getFilteringStrategy() <em>Filtering Strategy</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFilteringStrategy()
   * @generated
   * @ordered
   */
  protected FilteringStrategy filteringStrategy;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FilteringClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.FILTERING_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilteringRule getFilteringRule()
  {
    return filteringRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFilteringRule(FilteringRule newFilteringRule, NotificationChain msgs)
  {
    FilteringRule oldFilteringRule = filteringRule;
    filteringRule = newFilteringRule;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE, oldFilteringRule, newFilteringRule);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFilteringRule(FilteringRule newFilteringRule)
  {
    if (newFilteringRule != filteringRule)
    {
      NotificationChain msgs = null;
      if (filteringRule != null)
        msgs = ((InternalEObject)filteringRule).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE, null, msgs);
      if (newFilteringRule != null)
        msgs = ((InternalEObject)newFilteringRule).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE, null, msgs);
      msgs = basicSetFilteringRule(newFilteringRule, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE, newFilteringRule, newFilteringRule));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilteringStrategy getFilteringStrategy()
  {
    return filteringStrategy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetFilteringStrategy(FilteringStrategy newFilteringStrategy, NotificationChain msgs)
  {
    FilteringStrategy oldFilteringStrategy = filteringStrategy;
    filteringStrategy = newFilteringStrategy;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY, oldFilteringStrategy, newFilteringStrategy);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFilteringStrategy(FilteringStrategy newFilteringStrategy)
  {
    if (newFilteringStrategy != filteringStrategy)
    {
      NotificationChain msgs = null;
      if (filteringStrategy != null)
        msgs = ((InternalEObject)filteringStrategy).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY, null, msgs);
      if (newFilteringStrategy != null)
        msgs = ((InternalEObject)newFilteringStrategy).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY, null, msgs);
      msgs = basicSetFilteringStrategy(newFilteringStrategy, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY, newFilteringStrategy, newFilteringStrategy));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE:
        return basicSetFilteringRule(null, msgs);
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY:
        return basicSetFilteringStrategy(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE:
        return getFilteringRule();
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY:
        return getFilteringStrategy();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE:
        setFilteringRule((FilteringRule)newValue);
        return;
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY:
        setFilteringStrategy((FilteringStrategy)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE:
        setFilteringRule((FilteringRule)null);
        return;
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY:
        setFilteringStrategy((FilteringStrategy)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_RULE:
        return filteringRule != null;
      case DescartesQLPackage.FILTERING_CLAUSE__FILTERING_STRATEGY:
        return filteringStrategy != null;
    }
    return super.eIsSet(featureID);
  }

} //FilteringClauseImpl
