/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.domain;

import java.math.BigDecimal;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Confidence Interval</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getAccuracy <em>Accuracy</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getIntervalHalfLength <em>Interval Half Length</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getConfidenceInterval()
 * @model
 * @generated
 */
public interface ConfidenceInterval extends EObject {
	/**
	 * Returns the value of the '<em><b>Accuracy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Accuracy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Accuracy</em>' attribute.
	 * @see #setAccuracy(BigDecimal)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getConfidenceInterval_Accuracy()
	 * @model
	 * @generated
	 */
	BigDecimal getAccuracy();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getAccuracy <em>Accuracy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Accuracy</em>' attribute.
	 * @see #getAccuracy()
	 * @generated
	 */
	void setAccuracy(BigDecimal value);

	/**
	 * Returns the value of the '<em><b>Interval Half Length</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interval Half Length</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interval Half Length</em>' attribute.
	 * @see #setIntervalHalfLength(BigDecimal)
	 * @see tools.descartes.dql.models.mapping.domain.DomainPackage#getConfidenceInterval_IntervalHalfLength()
	 * @model
	 * @generated
	 */
	BigDecimal getIntervalHalfLength();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.domain.ConfidenceInterval#getIntervalHalfLength <em>Interval Half Length</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interval Half Length</em>' attribute.
	 * @see #getIntervalHalfLength()
	 * @generated
	 */
	void setIntervalHalfLength(BigDecimal value);

} // ConfidenceInterval
