/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.filter;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Binary Conjunction</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLeftConjunction <em>Left Conjunction</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getRightConjunction <em>Right Conjunction</em>}</li>
 *   <li>{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLogicalOperator <em>Logical Operator</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.models.mapping.filter.FilterPackage#getBinaryConjunction()
 * @model
 * @generated
 */
public interface BinaryConjunction extends Conjunction {
	/**
	 * Returns the value of the '<em><b>Left Conjunction</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Left Conjunction</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Left Conjunction</em>' reference.
	 * @see #setLeftConjunction(Conjunction)
	 * @see tools.descartes.dql.models.mapping.filter.FilterPackage#getBinaryConjunction_LeftConjunction()
	 * @model required="true"
	 * @generated
	 */
	Conjunction getLeftConjunction();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLeftConjunction <em>Left Conjunction</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Left Conjunction</em>' reference.
	 * @see #getLeftConjunction()
	 * @generated
	 */
	void setLeftConjunction(Conjunction value);

	/**
	 * Returns the value of the '<em><b>Right Conjunction</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Right Conjunction</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Right Conjunction</em>' reference.
	 * @see #setRightConjunction(Conjunction)
	 * @see tools.descartes.dql.models.mapping.filter.FilterPackage#getBinaryConjunction_RightConjunction()
	 * @model required="true"
	 * @generated
	 */
	Conjunction getRightConjunction();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getRightConjunction <em>Right Conjunction</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Right Conjunction</em>' reference.
	 * @see #getRightConjunction()
	 * @generated
	 */
	void setRightConjunction(Conjunction value);

	/**
	 * Returns the value of the '<em><b>Logical Operator</b></em>' attribute.
	 * The literals are from the enumeration {@link tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Logical Operator</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Logical Operator</em>' attribute.
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator
	 * @see #setLogicalOperator(BinaryConjunctionOperator)
	 * @see tools.descartes.dql.models.mapping.filter.FilterPackage#getBinaryConjunction_LogicalOperator()
	 * @model
	 * @generated
	 */
	BinaryConjunctionOperator getLogicalOperator();

	/**
	 * Sets the value of the '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLogicalOperator <em>Logical Operator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Logical Operator</em>' attribute.
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator
	 * @see #getLogicalOperator()
	 * @generated
	 */
	void setLogicalOperator(BinaryConjunctionOperator value);

} // BinaryConjunction
