/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.mapping.filter;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dql.models.mapping.filter.FilterFactory
 * @model kind="package"
 * @generated
 */
public interface FilterPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "filter";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://tools.descartes/dql/models/mapping/filter/1.0";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "filter";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FilterPackage eINSTANCE = tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.filter.impl.ConjunctionImpl <em>Conjunction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.filter.impl.ConjunctionImpl
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getConjunction()
	 * @generated
	 */
	int CONJUNCTION = 0;

	/**
	 * The number of structural features of the '<em>Conjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONJUNCTION_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.filter.impl.UnaryConjunctionImpl <em>Unary Conjunction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.filter.impl.UnaryConjunctionImpl
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getUnaryConjunction()
	 * @generated
	 */
	int UNARY_CONJUNCTION = 1;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_CONJUNCTION__CONDITION = CONJUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Unary Conjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNARY_CONJUNCTION_FEATURE_COUNT = CONJUNCTION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.filter.impl.BinaryConjunctionImpl <em>Binary Conjunction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.filter.impl.BinaryConjunctionImpl
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getBinaryConjunction()
	 * @generated
	 */
	int BINARY_CONJUNCTION = 2;

	/**
	 * The feature id for the '<em><b>Left Conjunction</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_CONJUNCTION__LEFT_CONJUNCTION = CONJUNCTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Right Conjunction</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_CONJUNCTION__RIGHT_CONJUNCTION = CONJUNCTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Logical Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_CONJUNCTION__LOGICAL_OPERATOR = CONJUNCTION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Binary Conjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BINARY_CONJUNCTION_FEATURE_COUNT = CONJUNCTION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link java.lang.Comparable<Condition> <em>Comparable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.lang.Comparable<Condition>
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getComparable()
	 * @generated
	 */
	int COMPARABLE = 6;

	/**
	 * The number of structural features of the '<em>Comparable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARABLE_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.filter.impl.ConditionImpl <em>Condition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.filter.impl.ConditionImpl
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getCondition()
	 * @generated
	 */
	int CONDITION = 3;

	/**
	 * The number of structural features of the '<em>Condition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITION_FEATURE_COUNT = COMPARABLE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.filter.impl.ClassRegexCondtionImpl <em>Class Regex Condtion</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.filter.impl.ClassRegexCondtionImpl
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getClassRegexCondtion()
	 * @generated
	 */
	int CLASS_REGEX_CONDTION = 4;

	/**
	 * The feature id for the '<em><b>Class Pattern</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_REGEX_CONDTION__CLASS_PATTERN = CONDITION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Class Regex Condtion</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLASS_REGEX_CONDTION_FEATURE_COUNT = CONDITION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.filter.impl.InstanceOfConditionImpl <em>Instance Of Condition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.filter.impl.InstanceOfConditionImpl
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getInstanceOfCondition()
	 * @generated
	 */
	int INSTANCE_OF_CONDITION = 5;

	/**
	 * The feature id for the '<em><b>Instance Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_OF_CONDITION__INSTANCE_NAME = CONDITION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Instance Of Condition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_OF_CONDITION_FEATURE_COUNT = CONDITION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator <em>Binary Conjunction Operator</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator
	 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getBinaryConjunctionOperator()
	 * @generated
	 */
	int BINARY_CONJUNCTION_OPERATOR = 7;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.filter.Conjunction <em>Conjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conjunction</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.Conjunction
	 * @generated
	 */
	EClass getConjunction();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.filter.UnaryConjunction <em>Unary Conjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unary Conjunction</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.UnaryConjunction
	 * @generated
	 */
	EClass getUnaryConjunction();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.filter.UnaryConjunction#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Condition</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.UnaryConjunction#getCondition()
	 * @see #getUnaryConjunction()
	 * @generated
	 */
	EReference getUnaryConjunction_Condition();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction <em>Binary Conjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Binary Conjunction</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunction
	 * @generated
	 */
	EClass getBinaryConjunction();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLeftConjunction <em>Left Conjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Left Conjunction</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLeftConjunction()
	 * @see #getBinaryConjunction()
	 * @generated
	 */
	EReference getBinaryConjunction_LeftConjunction();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getRightConjunction <em>Right Conjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Right Conjunction</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunction#getRightConjunction()
	 * @see #getBinaryConjunction()
	 * @generated
	 */
	EReference getBinaryConjunction_RightConjunction();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLogicalOperator <em>Logical Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Logical Operator</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunction#getLogicalOperator()
	 * @see #getBinaryConjunction()
	 * @generated
	 */
	EAttribute getBinaryConjunction_LogicalOperator();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.filter.Condition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Condition</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.Condition
	 * @generated
	 */
	EClass getCondition();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.filter.ClassRegexCondtion <em>Class Regex Condtion</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Class Regex Condtion</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.ClassRegexCondtion
	 * @generated
	 */
	EClass getClassRegexCondtion();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.filter.ClassRegexCondtion#getClassPattern <em>Class Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Class Pattern</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.ClassRegexCondtion#getClassPattern()
	 * @see #getClassRegexCondtion()
	 * @generated
	 */
	EAttribute getClassRegexCondtion_ClassPattern();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dql.models.mapping.filter.InstanceOfCondition <em>Instance Of Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Of Condition</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.InstanceOfCondition
	 * @generated
	 */
	EClass getInstanceOfCondition();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dql.models.mapping.filter.InstanceOfCondition#getInstanceName <em>Instance Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Instance Name</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.InstanceOfCondition#getInstanceName()
	 * @see #getInstanceOfCondition()
	 * @generated
	 */
	EAttribute getInstanceOfCondition_InstanceName();

	/**
	 * Returns the meta object for class '{@link java.lang.Comparable<Condition> <em>Comparable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comparable</em>'.
	 * @see java.lang.Comparable<Condition>
	 * @model instanceClass="java.lang.Comparable<Condition>"
	 * @generated
	 */
	EClass getComparable();

	/**
	 * Returns the meta object for enum '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator <em>Binary Conjunction Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Binary Conjunction Operator</em>'.
	 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator
	 * @generated
	 */
	EEnum getBinaryConjunctionOperator();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FilterFactory getFilterFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.filter.impl.ConjunctionImpl <em>Conjunction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.filter.impl.ConjunctionImpl
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getConjunction()
		 * @generated
		 */
		EClass CONJUNCTION = eINSTANCE.getConjunction();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.filter.impl.UnaryConjunctionImpl <em>Unary Conjunction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.filter.impl.UnaryConjunctionImpl
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getUnaryConjunction()
		 * @generated
		 */
		EClass UNARY_CONJUNCTION = eINSTANCE.getUnaryConjunction();

		/**
		 * The meta object literal for the '<em><b>Condition</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNARY_CONJUNCTION__CONDITION = eINSTANCE.getUnaryConjunction_Condition();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.filter.impl.BinaryConjunctionImpl <em>Binary Conjunction</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.filter.impl.BinaryConjunctionImpl
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getBinaryConjunction()
		 * @generated
		 */
		EClass BINARY_CONJUNCTION = eINSTANCE.getBinaryConjunction();

		/**
		 * The meta object literal for the '<em><b>Left Conjunction</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_CONJUNCTION__LEFT_CONJUNCTION = eINSTANCE.getBinaryConjunction_LeftConjunction();

		/**
		 * The meta object literal for the '<em><b>Right Conjunction</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BINARY_CONJUNCTION__RIGHT_CONJUNCTION = eINSTANCE.getBinaryConjunction_RightConjunction();

		/**
		 * The meta object literal for the '<em><b>Logical Operator</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BINARY_CONJUNCTION__LOGICAL_OPERATOR = eINSTANCE.getBinaryConjunction_LogicalOperator();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.filter.impl.ConditionImpl <em>Condition</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.filter.impl.ConditionImpl
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getCondition()
		 * @generated
		 */
		EClass CONDITION = eINSTANCE.getCondition();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.filter.impl.ClassRegexCondtionImpl <em>Class Regex Condtion</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.filter.impl.ClassRegexCondtionImpl
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getClassRegexCondtion()
		 * @generated
		 */
		EClass CLASS_REGEX_CONDTION = eINSTANCE.getClassRegexCondtion();

		/**
		 * The meta object literal for the '<em><b>Class Pattern</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CLASS_REGEX_CONDTION__CLASS_PATTERN = eINSTANCE.getClassRegexCondtion_ClassPattern();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.filter.impl.InstanceOfConditionImpl <em>Instance Of Condition</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.filter.impl.InstanceOfConditionImpl
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getInstanceOfCondition()
		 * @generated
		 */
		EClass INSTANCE_OF_CONDITION = eINSTANCE.getInstanceOfCondition();

		/**
		 * The meta object literal for the '<em><b>Instance Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INSTANCE_OF_CONDITION__INSTANCE_NAME = eINSTANCE.getInstanceOfCondition_InstanceName();

		/**
		 * The meta object literal for the '{@link java.lang.Comparable<Condition> <em>Comparable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.lang.Comparable<Condition>
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getComparable()
		 * @generated
		 */
		EClass COMPARABLE = eINSTANCE.getComparable();

		/**
		 * The meta object literal for the '{@link tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator <em>Binary Conjunction Operator</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dql.models.mapping.filter.BinaryConjunctionOperator
		 * @see tools.descartes.dql.models.mapping.filter.impl.FilterPackageImpl#getBinaryConjunctionOperator()
		 * @generated
		 */
		EEnum BINARY_CONJUNCTION_OPERATOR = eINSTANCE.getBinaryConjunctionOperator();

	}

} //FilterPackage
